#!/usr/bin/python
from core import public_handlers, private_handlers, login_handlers, logout_handlers
import traceback
import imp
import os
modules = {}

def load_module(name):
    unload_module(name)
    try:
        print "Loading module " + name
        modules[name] = reload_module(name) 
        print modules[name]
        modules[name].init_module()
        print "Module " + name + " loaded !"
    except Exception:
        print "Load failed"
        traceback.print_exc()
        
        
def unload_module(name):
    try:
        modules[name]
        try:
            modules[name].unload_module()
        except:
            print "Unable to execute unload_module"
        del modules[name]
        print "Module unloaded."
    except Exception:
        print "Nothing was unloaded"
    
        
def add_message_handler (fn):
    public_handlers.append(fn)
    
def delete_message_handler (fn):
    try:
        public_handlers.remove(fn)
    except Exception:
        print "Handler doesn't exit"

def add_private_handler (fn):
    private_handlers.append(fn)
    
def delete_private_handler (fn):
    try:
        private_handlers.remove(fn)
    except Exception:
        print "Handler doesn't exit"

def add_connect_handler (fn):
    login_handlers.append(fn)

def add_disconnect_handler (fn):
    logout_handlers.append(fn)

def delete_connect_handler (fn):
    try:
        login_handlers.remove(fn)
    except Exception:
        print "Handler doesn't exit"

def delete_disconnect_handler (fn):
    try:
        logout_handlers.remove(fn)
    except Exception:
        print "Handler doesn't exit"
        
def reload_module (name):
   return imp.load_source(name, os.path.dirname(__file__)+"/modules/"+name+".py")


    
