#!/usr/bin/python
import loader

password = "123456"
allowed_admins = ["username!usermask@host"]
admin_handlers = []

#Creating handlers manipulation
def add_admin_handler (fn):
    admin_handlers.append(fn)
    
def delete_admin_handler (fn):
    try:
        admin_handlers.remove(fn)
    except Exception:
        print "Handler doesn't exit"

#Private message handler
def priv_handler(msg, nick, ident, s):
    if msg[0:5] == "ident":
        if msg[6:].rstrip() == password:
            try: 
                allowed_admins.index(ident)
            except Exception:
                allowed_admins.append(ident)
        else:
            s.send ("PRIVMSG " + nick + " :Wrong password\r\n")
            print "Bad pwd given"
    else:
        try:
            allowed_admins.index(ident)
            for cmd in admin_handlers:
                cmd (msg, nick, ident, s)
        except Exception:
            print "Not admin"

#Common admin handler
def adm_handler(msg, nick, ident, s):
    command = msg.rstrip().split(' ')
    #Makes the bot join
    if(command[0] == "join"):
        s.send ("JOIN " + command[1] + "\r\n")
    #Makes the bot part
    if(command[0] == "part"):
        s.send("PART " + command[1] + "\r\n")
    #Makes the bot speak on a chan
    if(command[0] == "speak"):
        command_params = msg[6:]
        space_pos = command_params.find(" ")
        if space_pos != -1:
            room = command_params[:space_pos]
            data = command_params[space_pos+1:].rstrip()
            s.send("PRIVMSG " + room + " :" + data + "\r\n")
    #Makes the bot act on a chan
    if(command[0] == "act"):
        command_params = msg[4:]
        space_pos = command_params.find(" ")
        if space_pos != -1:
            room = command_params[:space_pos]
            data = command_params[space_pos+1:].rstrip()
            s.send("PRIVMSG " + room + " :\001ACTION " + data + "\001\r\n")
    if(command[0] == "unload"):
        if command[1] == "admin":
            s.send("PRIVMSG " + nick + " :Can't unload myself !\r\n")
        else:
            loader.unload_module(command[1])
    if(command[0] == "load"):
        loader.load_module(command[1])
    
def init_module():
    loader.add_admin_handler = add_admin_handler
    loader.delete_admin_handler = delete_admin_handler
    loader.add_private_handler(priv_handler)
    loader.add_admin_handler(adm_handler)

def unload_module():
    loader.delete_admin_handler(adm_handler)
    loader.delete_private_handler(priv_handler)
    del loader.add_admin_handler
    del loader.delete_admin_handler


