#!/usr/bin/python
#-*- coding: utf-8 -*-

import loader
import urllib
import feedparser

bonjour_rss =     {"madame": "http://feeds2.feedburner.com/BonjourMadame", 
				   "monsieur": "http://www.bonjourmonsieur.fr/feed",
				   "lecul": "http://feeds2.feedburner.com/BonjourLecul",
				   "sushi": "http://www.bonjoursushi.fr/rss/",
				   "lesgeeks": "http://bonjourlesgeeks.com/rss/",
				   "mademoiselle": "http://bonjourmademoiselle.fr/rss/"}
	
bonjour_message = {"madame": "madame :p",
				   "monsieur": "monsieur (pour les filles) :p",
				   "lecul": "le cul :p",
				   "sushi": "sushi :p (pour les gourmands !)",
				   "lesgeeks": "les geeks :p",
				   "mademoiselle": "mademoiselle :p"}

def bonjour(mode):
    if(mode in bonjour_rss):
        feed = feedparser.parse(bonjour_rss[mode])
        try:
            lastItem = feed["items"][0]
            link = lastItem["description"]
            if(link.find("src=")!=-1):
	            link = link[link.find("src=")+5:]
	            link = link[:link.find('"')]
	            return "Bonjour " + bonjour_message[mode] + " " + link
            return "Bonjour " + bonjour_message[mode] + ", il n'y a rien à afficher :("
        except IndexError:
          return "Bonjour " + bonjour_message[mode] + ", impossible de récupérer l'image :("
    return "Bonjour " + mode + " :p"

def public_hand (message, chan, nick, ident, s):
    print chan + " " + nick + " " + message
    if(message[0:8] == "!bonjour"):
	    to_say = message[8:].rstrip()
	    if(to_say != "tous"):
		    s.send("PRIVMSG " + chan + " :" + bonjour(to_say) + "\r\n")
    if(message[0:12] == "!bonjourtous"):
		iter_madame = bonjour_message.iteritems()
		for i in bonjour_message:
			s.send("PRIVMSG " + chan + " :" + bonjour(i) + "\r\n")
    
def init_module():
    loader.add_message_handler(public_hand)

def unload_module():
    loader.delete_message_handler(public_hand)
