#!/usr/bin/python
#-*- coding: utf-8 -*-

import socket
import array
import time
import urllib
import os
import sys
from threading import *
import loader
import traceback

public_handlers = []
private_handlers = []
login_handlers = []
logout_handlers = []
data_handlers = []

disconnected = True
#Coeur du bot
def parse_data(msg,s, passw, chans):
    #Détection d'une connexion fructueuse
    if(msg.find("376 ") != -1 or msg.find("422 ") != -1):
        print msg
        if(passw != ""):
            s.send("PRIVMSG NickServ :identify " + passw + "\r\n")
        for chan in chans:
            s.send("JOIN " + chan + "\r\n")
            
            #On fait tourner les hooks de connexion
            for cmd in login_handlers:
                try:
                    cmd(s)
                except Exception:
                    print "Execution of login handler failed"
                    traceback.print_exc()
    #Réponse au ping
    if(msg[0:4] == "PING"):
        answer = msg.split(' ')
        s.send("PONG " + answer[1] + "\r\n")

    #si on reçoit un message
    privmsg_offset = msg.find("PRIVMSG ")
    if(privmsg_offset != -1):
        # Grab username & full ident of the bot
        nickname = msg[1:msg.find("!")]
        full_ident = msg[1:msg.find(" ")]
        args = msg[privmsg_offset+8:].split(" :")
        message = " :".join(args[1:])
        if(args[0].find("#") == 0):
            #Public message
            for cmd in public_handlers:
                try:
                    cmd (message, args[0], nickname, full_ident, s) # on exécute les handlers associés
                except Exception:
                    print "Execution of message handler failed"
                    traceback.print_exc()
        else:
            #Private message
            for cmd in private_handlers:
                try:
                    cmd (message, nickname, full_ident, s) # on exécute les handlers associés
                except Exception:
                    print "Execution of message handler failed"
                    traceback.print_exc()
    else:
        # On exécute les hooks "global handler"
        print "global handler triggered for: " + msg.rstrip()
        for cmd in data_handlers:
            try:
                cmd (msg, s) # on exécute les handlers associés
            except Exception:
                print "Execution of message handler failed"
                traceback.print_exc()
                    
def korebot(conf):
    global disconnected
    loader.load_module("admin")
    for mod in conf["modules"]:
        loader.load_module(mod)
    try:
        # Création de la socket
        s = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
        s.connect((conf["server"],6667))
        # Envoi des infos de l'utilisateur
        s.send("USER " + conf["nick"] + " in.the.wc " +conf["nick"] + " :" + conf["realname"] +"\r\n")
        time.sleep(1)
        #Envoi des infos de nick
        s.send("NICK " + conf["nick"] + "\r\n")
        fs = s.makefile()
        disconnected = False
        
        #Boucle du bot    
        while disconnected==False:
            buffer = fs.readline()
            if(buffer != ""):
                parse_data(buffer, s, conf["passw"], conf["chans"])
            if not buffer:
                for cmd in logout_handlers:
                    try:
                        cmd()
                    except Exception:
                        print "Execution of message handler failed"
                        traceback.print_exc()
                disconnected = True
                
    except socket.error:
        s.close()
        disconnected = True
    for mod in conf["modules"]:
        loader.unload_module(mod)
    loader.unload_module("admin")
