#!/usr/bin/python
#-*- coding: utf-8 -*-

from threading import *        
import loader
import core
import traceback
import urllib2
import json

canRun = True
lastpost = ""
url_to_parse = "http://n-pn.info/forum/"

def rss_grab(s):
    global lastpost
    try:
        url = urllib2.build_opener()
        req = url.open(url_to_parse + "misc.php?action=getlastpost")
        res = req.read()
        #Récupération du premier lien de la page des nouveaux messages
        data = json.loads(res)
        if (data["lastpost"] != lastpost):
            s.send("PRIVMSG #n-pn :\003» [New post @forum] \0034" + data["title"].encode("utf-8") + "\003 by \0034" + data["lastposter"].encode("utf-8")  + "\003 - \0032" + url_to_parse + "showthread.php?tid="+data["tid"].encode("utf-8") + "&action=lastpost\r\n")
            lastpost = data["lastpost"]
    except Exception:
        print "Something went wrong... :("
        traceback.print_exc()
    if canRun:
        thx = Timer(interval=30, function=rss_grab, kwargs={"s":s})
        thx.start()

def disconnect_handle():
    canRun = False
    
def connect_handle (s):
    thx = Timer(interval=5, function=rss_grab, kwargs={"s":s})
    thx.start()

def init_module():
    # Lance le thread qui va récupérer le RSS des présentations
    loader.add_connect_handler(connect_handle)
    loader.add_disconnect_handler(disconnect_handle)

def unload_module():
    loader.delete_connect_handler(connect_handle)
    loader.delete_disconnect_handler(disconnect_handle)
